/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/


GUI_Manager = function() {
	
	//Atributos
	this.nav = new Object(); 
	
	//Mtodos
	this.init = function() {
		//Hacemos que los bloques puedan moverse
		Sortable.create("center_zone_content",
			{tag:'li',
			 dropOnEmpty:true,
			 constraint:"vertical",
			 overlap:"vertical",
			 handle:"center_zone_sortable_handler",
			 zindex:1});
		
		Sortable.create("tabs",
			{tag:'li',
			 dropOnEmpty:true,
			 constraint:"horizontal",
			 overlap:"horizontal",
			 zindex:1});
		
		Sortable.create("main",
			{tag:'li',
			 dropOnEmpty:true,
			 constraint:"horizontal",
			 overlap:"horizontal",
			 handle:"main_sortable_handler",
			 zindex:1});
		
		Sortable.create("result_tabs",
			{tag:'li',
			 dropOnEmpty:true,
			 constraint:"horizontal",
			 overlap:"horizontal",
			 zindex:1});
			
		/* Hacemos que los bloques puedan redimensionarse */
		new Resizeable("editor_zone_content", 
			{top:0,
			 left:0,
			 right:0,
			 bottom:0,
			 zindex:1,
			 minHeight:300,
			 handle: {id:'editor_zone_content_resize_handler', cursor:'s'},
			 startResize: function(e) {
				 $('editor_zone_content_form').style.visibility = 'hidden';
			 },
			 endResize: function(e, ui) {
				$('editor_zone_content_form').style.visibility = 'visible';
			 }
			 });
		
		new Resizeable("result_zone_content", 
			{top:0,
			 left:0,
			 right:0, 
			 zindex:1,
			 minHeight:180});
		
		new Resizeable("center_zone", 
			{top:0,
			 bottom:0,
			 left:0, 
			 right:0,
			 zindex:1,
			 minWidth:580,
			 handle: {id:'center_zone_resize_handler', cursor:'e'},
			 startResize: function(e) {
				 $('editor_zone_content_form').style.visibility = 'hidden';				 
			 },
			 endResize: function(e, ui) {
				$('editor_zone_content_form').style.visibility = 'visible';
			 }
			 });
		
		new Resizeable("right_zone", 
			{top:0,
			 bottom:0,
			 left:0,
			 right:0,
			 minWidth:180,
			 zindex:1,
			 handle:{id:'right_zone_resize_handler', cursor:'e'}
			 });
		
		//Obtenemos el navigador web del cliente
		this.get_navigator();
	}
	
	this.show_handler = function(obj) {
		if (obj)
			obj.effect = new Effect.Opacity(obj,{from:0.15,to:1,duration:1});
	}
	
	this.hidde_handler = function(obj) {
		if(obj.effect)
			obj.effect = new Effect.Opacity(obj,{from:obj.effect.position,to:0.15,duration:0.75,afterFinish:obj.effect.cancel()});
	}
	
	
	//Navigator identification
	this.get_navigator = function() {
		
		var ua = navigator.userAgent;
		
		this.nav['isMacOS'] = (ua.indexOf('Mac OS') != -1);
		
		this.nav['isIE'] = (navigator.appName == "Microsoft Internet Explorer");
		
		if(this.nav['isIE']){
			this.nav['isIE'] = ua.replace(/^.*?MSIE ([0-9\.]*).*$/, "$1");
			if(this.nav['isIE']<6)
				//this.has_error(); 
				alert("Incorrect version of navigator");				
		}
		
		if(this.nav['isNS'] = ua.indexOf('Netscape/') != -1){	// work only on netscape > 8 with render mode IE
			this.nav['isNS']= ua.substr(ua.indexOf('Netscape/')+9);
			if(this.nav['isNS']<8 || !this.nav['isIE'])
				//this.has_error();
				alert("Incorrect version of navigator");				
		}
		
		if(this.nav['isOpera'] = (ua.indexOf('Opera') != -1)){	
			this.nav['isOpera']= ua.replace(/^.*?Opera.*?([0-9\.]+).*$/i, "$1");
			if(this.nav['isOpera']<9)
				//this.has_error();
				alert("Incorrect version of navigator");				
			this.nav['isIE']=false;			
		}
		
		this.nav['isGecko'] = (ua.indexOf('Gecko') != -1);
	
		if(this.nav['isFirefox'] = (ua.indexOf('Firefox') != -1))
			this.nav['isFirefox'] = ua.replace(/^.*?Firefox.*?([0-9\.]+).*$/i, "$1");
			
		// Iceweasel is a clone of Firefox 	
		if(this.nav['isIceweasel'] =(ua.indexOf('Iceweasel') != -1))
			this.nav['isFirefox']= this.nav['isIceweasel'] = ua.replace(/^.*?Iceweasel.*?([0-9\.]+).*$/i, "$1");
		// grandparadisio is a clone of Firefox 	
		if(this.nav['GranParadiso'] =(ua.indexOf('GranParadiso') != -1))
			this.nav['isFirefox']= this.nav['isGranParadiso'] = ua.replace(/^.*?GranParadiso.*?([0-9\.]+).*$/i, "$1");
		// BonEcho is a clone of Firefox
		if(this.nav['BonEcho'] =(ua.indexOf('BonEcho') != -1))
			this.nav['isFirefox']= this.nav['isBonEcho'] = ua.replace(/^.*?BonEcho.*?([0-9\.]+).*$/i, "$1");
		if(this.nav['isCamino'] =(ua.indexOf('Camino') != -1))
			this.nav['isCamino'] = ua.replace(/^.*?Camino.*?([0-9\.]+).*$/i, "$1");
		if(this.nav['isChrome'] =(ua.indexOf('Chrome') != -1))
			this.nav['isChrome'] = ua.replace(/^.*?Chrome.*?([0-9\.]+).*$/i, "$1");
		
		if(this.nav['isSafari'] =(ua.indexOf('Safari') != -1))
			this.nav['isSafari']= ua.replace(/^.*?Version\/([0-9]+\.[0-9]+).*$/i, "$1");
		
		if(this.nav['isIE']>=6 || this.nav['isOpera']>=9 || this.nav['isFirefox'] || this.nav['isChrome'] || this.nav['isCamino'] || this.nav['isSafari']>=3)
			this.nav['isValidBrowser']=true;
		else
			this.nav['isValidBrowser']=false;
			
	}	
	
	
	/*
	this.show_layer_off = function(status) {
		var layer_off = $('layer_off');
		var layer_all = $('all');
		if (status) {
			layer_off.style.display = 'block';
			layer_off.style.width = document.body.offsetWidth+"px";
			//layer_off.style.height = document.body.offsetHeight+"px";
			layer_off.style.height = layer_all.scrollHeight+"px"
		}
		else {
			layer_off.style.display = 'none';			
		}
	}
	*/
	
	
	/*
	this.show_loading_panel = function(status) {
		var layer_all = $('all');
		var loading_panel = $('loading_panel');
		
		if (status) {
			loading_panel.style.display = 'block';
			loading_panel.style.left = (document.body.offsetWidth/2 - loading_panel.style.width) +"px";
			loading_panel.style.top = (document.body.offsetHeight/2 - loading_panel.style.height) +"px";
		}
		else {
			loading_panel.style.display = 'none';			
		}
	}
	*/
	
}

	
var gui_manager = new GUI_Manager();	
