// WebDevStudio - www.webdevstudio.org
// Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)
// 
// This code is substantially based on code from EditArea under 
// its licenses

Keyboard_Manager = function() {
	
	
	
	this.init = function() {
		//Init key events
		if(gui_manager.nav['isOpera']) {
			document.onkeypress = keyboard_manager.key_down;
		}
		else {
			document.onkeydown = keyboard_manager.key_down;
		}
	}
		
	
	this.key_down = function(ev) {
		
		var EA_keys = {13:"Enter"};
		
		var e = window.event || ev;

		if (EA_keys[e.keyCode]) {
			var letter = EA_keys[e.keyCode];
		}
		else {
			var letter = String.fromCharCode(e.keyCode);
		}
		var low_letter = letter.toLowerCase();


		if (letter=="Enter" && ctrl_pressed(e) && shift_pressed(e) && !alt_pressed(e)) {
			actions_manager.compile();
		}
		else if (letter=="Enter" && ctrl_pressed(e) && shift_pressed(e) && alt_pressed(e)) {
			actions_manager.build();
		}
		else if(ctrl_pressed(e) && alt_pressed(e) && shift_pressed(e)){
			switch(low_letter) {
				case "n":
					windows_manager.show_newfolder_window(PATH_PROJECT);
					break;
				case "s":
					actions_manager.save_all_files();
					break;

				default:
					break;
			}
		}
		else if (ctrl_pressed(e)  && shift_pressed(e)){
			switch(low_letter){
				case "n":
					windows_manager.show_newfile_window(PATH_PROJECT);
					break;
				case "s":
					actions_manager.save_act_file();
					break;
				case "u":
					actions_manager.up_file();
					break;
				case "d":
					actions_manager.down_act_file();
					break;
				case "b":
					actions_manager.backup()
					break;
				case "p":
					actions_manager.print_code();
					break;					
				/*
				case "x":
					actions_manager.cut();
					break;
				case "c":
					actions_manager.copy();
					break;
				case "v":
					actions_manager.paste();
					break;
				case "z":
					actions_manager.undo();
					break;
				case "y":
					actions_manager.redo();
				*/
				case "f":
					actions_manager.show_search();
					break;
				case "g":
					actions_manager.go_to_line();
					break;
				case "w":
					actions_manager.toggle_full_screen();
					break;
				case "e":
					actions_manager.help();
					break;
				default:
					break;			
			}		
		}		
		
	}

	// return true if Alt key is pressed
	alt_pressed = function(e) {
		if (window.event) {
			return (window.event.altKey);
		} else {
			if(e.modifiers)
				return (e.altKey || (e.modifiers % 2));
			else
				return e.altKey;
		}
	}

	// return true if Ctrl key is pressed
	ctrl_pressed = function(e) {
		if (window.event) {
			return (window.event.ctrlKey);
		}
		else {
			return (e.ctrlKey || (e.modifiers==2) || (e.modifiers==3) || (e.modifiers>5));
		}
	}
	
	// return true if Shift key is pressed
	shift_pressed = function(e) {
		if (window.event) {
			return (window.event.shiftKey);
		}
		else {
			return (e.shiftKey || (e.modifiers>3));
		}
	}
	
}

keyboard_manager = new Keyboard_Manager();
