/*
WebDevStudio - www.webdevstudio.org
Copyright (C) 2006-2009 WebDevStudio Team (info@webdevstudio.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

Windows_Manager = function() {
	
	this.close_current_window = function() {
		Windows.getFocusedWindow().close();
	}
	
	this.close_all_windows = function() {
		Windows.closeAll();
		Windows.closeAllModalWindows();
	}

	
	
	//Actualiza la zona de exploracion de ficheros de la ventana
	//this.update_window_file_explorer = function(id, path, update_xml) {
	this.update_window_file_explorer = function(id, path) {
		//Mostramos el contenido de precarga antes de cargar
		$(id).innerHTML = '<img src="../../images/general/animated_loading_green.gif" align="top" /> Loading...';
		
		var contentHTML = ''+
			'<label for="path_newfile" style="width:40px;">Folder: </label>'+
			'<select id="path_newfile" style="width:300px" onchange="windows_manager.update_window_file_explorer(\''+id+'\', this.options[this.selectedIndex].value)">';
		
		//Obtenemos la lista de carpetas por debajo de nuestro nivel
		var folder_array = path.replace(/(\.\.\/)/gi, "").split("/");
		var separator = "";
		var path_value = PATH_USER; //Variable global
		
		for (var i=2; i<folder_array.length; i++) {
			if (i == folder_array.length-1) {
				contentHTML += '<option value="'+path_value+'/'+folder_array[i]+'" selected="selected">'+separator+folder_array[i]+'</option>';
			}
			else {
				contentHTML += '<option value="'+path_value+'/'+folder_array[i]+'">'+separator+folder_array[i]+'</option>';
			}
			path_value += '/'+folder_array[i];
			separator += '&nbsp;&nbsp;';
		}
		contentHTML += '</select>';
			
		//Obtenemos los ficheros para esa carpeta 
		contentHTML += '<div id="file_explorer" >';
		
		var content_folder = filetree_manager.get_content_folder(path, false, false);
		for(var i=0; i<content_folder.length; i++) {
			//alert(content_folder[i]['path']);
			if (content_folder[i]['type'] == "dir") {
				//contentHTML += '<div ondblclick="windows_manager.update_window_file_explorer(\''+id+'\', \''+content_folder[i]['path']+'\')" unselectable="on"><img src="'+content_folder[i]['image']+'" align="top" /> '+content_folder[i]['name']+'</div>';
				contentHTML += '<div style="cursor:pointer" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenufolder_explorer\', \''+content_folder[i]['path']+'\');return false;" ondblclick="windows_manager.update_window_file_explorer(\''+id+'\', \''+content_folder[i]['path']+'\')"><img src="'+content_folder[i]['image']+'" align="top" /> '+content_folder[i]['name']+'</div>';				
			}
			else {
				//contentHTML += '<div unselectable="on"><img src="'+content_folder[i]['image']+'" align="top" /> '+content_folder[i]['name']+'</div>';
				contentHTML += '<div onclick="windows_manager.set_name_window_file_data(\''+content_folder[i]['name']+'\')" oncontextmenu="dropmenu.dropdownmenu(event, this, \'dropmenufile_explorer\', \''+content_folder[i]['path']+'\');return false;"><img src="'+content_folder[i]['image']+'" align="top" /> '+content_folder[i]['name']+'</div>';
			}
		}
		contentHTML += '</div>';
		
		//Mostramos el contenido una vez cargado
		$(id).innerHTML = contentHTML;
	}
	
	
	//Actualiza la seccion de los datos del fichero
	this.update_window_file_data = function (id) {
		$(id).innerHTML = '<img src="../../images/general/animated_loading_green.gif" align="top" /> Loading...';
	
		//Mostramos los tipos de ficheros
		var selectHTML = '<select id="extension_newfile" name="extension_newfile" style="width:250px">';
		
		var file_extensions = filetree_manager.get_file_extensions();
		for (var i=0; i<file_extensions.length; i++) {
			selectHTML += '<option value=".'+file_extensions[i]['name']+'">'+file_extensions[i]['description']+' (*.'+file_extensions[i]['name']+')</option>';
		}
		selectHTML += '</select>';

		//Mostramos el campo donde poner el nombre dle fichero
		var contentHTML = ''+
			'<div>'+
				'<label for="name_newfile" style="width:50px;">Name: </label>'+
				'<input id="name_newfile" name="name_newfile" type="text" style="width:245px" />'+
				'<button onclick="windows_manager.submit_new_file()" style="width:70px;margin:0 10px 0 10px;">OK</button>'+
			'</div>'+
			'<div style="margin-top:5px">'+
				'<label for="extension_newfile" style="width:50px;">File type: </label>'+
				selectHTML+				
				'<button onclick="windows_manager.close_all_windows()" style="width:70px;margin:0 10px 0 10px;">Cancel</button>'+
				
			'</div>';
			
		//Mostramos el contenido una vez cargado
		$(id).innerHTML = contentHTML;
	}
	
	
	//Establece el nombre del fichero en el campo de la ventana
	this.set_name_window_file_data = function(name) {
		var sort_name = name.substr(0,name.lastIndexOf('.'));
		//Para las carpetas
		if (sort_name == '') {
			sort_name = name;
		}
		$('name_newfile').value = sort_name;
	}
	
	
	//New file window
	this.show_newfile_window = function(path) {
			
		//Configuramos la ventana
		var win = new Window({title: "New file", 
							  width:475, 
							  height:320, 
							  zIndex:3, 
							  minimizable: false, 
							  maximizable: false, 
							  destroyOnClose: true, 
							  recenterAuto:true, 
							  resizable:false,
							  showEffect: Element.show,
							  hideEffect: Element.hide});
		
		//Creamos las partes del contenido de la ventana
		var window_content = ''+
			'<div id="window_content">'+
				'<div id="window_file_explorer"></div>'+
				'<div id="window_file_data"></div>'+
			'</div>';
	
		//Mostramos la ventana
		win.setHTMLContent(window_content);
		win.showCenter(true);
		
		//Generamos el contenido del explorador de ficheros
		this.update_window_file_explorer('window_file_explorer', path);
	
		//Generamos el contenido de los datos del nuevo fichero
		this.update_window_file_data('window_file_data');
	}
	
	
	
	this.submit_new_file = function() {
		var element;
		//Obtenemos el nombre del fichero
		element = $('name_newfile');
		var file_name = element.value;
		
		//Chequeamos el nombre del fichero
		var error = false;
		if (file_name == "") {
			error = true;
		}
		else if (file_name.match(/[\\/:*?\""<>|\']/)) {
			error = true;
			alert("The file name is incorrect.\nPlease, don't use: \\,/,:,*,?,\",<,>,|,\'");
		}

		
		//Si se ha puesto nombre
		if (!error) {
			//Obtenemos del path
			element = $('path_newfile');
			var file_path = element.options[element.selectedIndex].value;
			
			//Obtenemos la extension
			element = $('extension_newfile');
			var file_extension_select = element.options[element.selectedIndex].value;
			
			//Eliminamos la extension del nombre del fichero si ya la tiene
			var file_extension = file_name.substring(file_name.length-file_extension_select.length, file_name.length);
			if((file_extension) == file_extension_select) {
				file_name = file_name.substring(0, file_name.length-file_extension.length);
			}			
			
			//Creamos el nombre final del fichero
			var newfile_path = file_path+'/'+file_name+file_extension_select;
			
			//Comprobamos que no existe ya un fichero con ese nuevo nombre
			if (filetree_manager.file_exists(newfile_path)) {
				var r = confirm("File exsists. Are you sure to overwrite this file?");
				if (r == true) {
					actions_manager.new_file(newfile_path);
				}
			}
			else {
				actions_manager.new_file(newfile_path);
			}
		}
	}
	
	
	//Rename file
	this.show_renamefile_window = function(path, modal) {
		//Configuramos la ventana
		var win = new Window({title: "Rename file", 
							  width:265, 
							  height:90, 
							  zIndex:3, 
							  minimizable: false, 
							  maximizable: false, 
							  destroyOnClose: true, 
							  recenterAuto:true, 
							  resizable:false,
							  showEffect: Element.show,
							  hideEffect: Element.hide
							  });
		
		//Nos quedamos con el nombre del fichero
		var file_name = path.substring(path.lastIndexOf("/")+1, path.length);
	
		//Creamos las partes del contenido de la ventana
		var window_content = ''+
		'<div id="window_content">'+
			'<div>'+
				'<label for="name_file" style="width:40px">Name: </label>'+
				'<input id="name_file" name="name_file" type="text" style="width:195px;" value="'+file_name+'" />'+
			'</div>'+
			'<div style="text-align:center;margin-top:10px">'+
				'<button onclick="windows_manager.submit_rename_file(\''+path+'\')" style="width:70px;margin:0 5px 0 5px;">OK</button>'+
				//'<button onclick="windows_manager.close_current_window()" style="width:70px;margin:0 5px 0 5px;">Cancel</button>'+
				'<button onclick="Windows.getFocusedWindow().close()" style="width:70px;margin:0 5px 0 5px;">Cancel</button>'+
			'</div>'+
		'</div>';
	
		//Mostramos la ventana
		win.setHTMLContent(window_content);
		win.showCenter(modal);
	}
	
	//this.submit_rename_file = function(path_file, name_file) {
	this.submit_rename_file = function(path_file) {
		//Obtenemos el nombre del fichero
		var file_name = $('name_file').value;
		
		//Comprobamos el nombre del fichero
		var error = false;
		if (file_name == "") {
			error = true;
		}
		else if (file_name.match(/[\\/:*?\""<>|\']/)) {
			error = true;
			alert("The file name is incorrect.\nPlease, don't use: \\,/,:,*,?,\",<,>,|,\'");
		}
		
		//Si se ha puesto nombre
		if (!error) {
			//Obtenemos el path
			var path = path_file.substring(0, path_file.lastIndexOf("/")+1);
			var newfile_path = path+file_name;
			
			//Comprobamos que no existe ya un fichero con ese nuevo nombre
			if (filetree_manager.file_exists(newfile_path)) {
				alert("File exists. Imposible to rename this file.");
			}
			else {
				//Cerramos la ventana
				//Windows.getFocusedWindow().close();
				this.close_current_window();
				//Llamamos a la accion				
				actions_manager.rename_file(path_file, newfile_path);
			}
		}		
	}
	

	
	
	//New folder window
	this.show_newfolder_window = function(path) {
		//Configuramos la ventana
		win = new Window({title: "New folder", 
						  width:475, 
						  height:290, 
						  zIndex:3, 
						  minimizable: false, 
						  maximizable: false, 
						  destroyOnClose: true, 
						  recenterAuto: true, 
						  resizable: false,
						  showEffect: Element.show,
						  hideEffect: Element.hide});

		//Creamos las partes del contenido de la ventana
		var window_content = ''+
			'<div id="window_content">'+
				'<div id="window_file_explorer"></div>'+
				'<div id="window_data">'+
			'</div>';
	
		//Mostramos la ventana
		win.setHTMLContent(window_content);
		win.showCenter(true);
		
		//Generamos el contenido del explorador de ficheros
		this.update_window_file_explorer('window_file_explorer', path);
		//Generamos el contenido de los datos del nuevo fichero
		this.update_window_folder_data('window_data');
	}
	
	
	//Actualiza la seccion de los datos del fichero
	this.update_window_folder_data = function (id) {
		$(id).innerHTML = '<img src="../../images/general/animated_loading_green.gif" align="top" /> Loading...';
		//Mostramos el campo donde poner el nombre dle fichero
		var contentHTML = ''+
			'<div>'+
				'<label for="name_newfile" style="width:35px;">Name: </label>'+
				'<input id="name_newfile" name="name_newfile" type="text" style="width:253px" />'+
				'<button onclick="windows_manager.submit_new_folder()" style="width:70px;margin:0 0 0 10px;">OK</button>'+
				'<button onclick="windows_manager.close_all_windows()" style="width:70px;margin:0 0 0 10px;">Cancel</button>'+
			'</div>';
		//Mostramos el contenido una vez cargado		
		$(id).innerHTML = contentHTML;
	}
	
	
	this.submit_new_folder = function() {
		var element;
		//Obtenemos el nombre del fichero
		var file_name = $('name_newfile').value;
		
		//Chequeamos el nombre del fichero
		var error = false;
		if (file_name == "") {
			error = true;
		}
		else if (file_name.match(/[\\/:*?\""<>|\']/)) {
			error = true;
			alert("The folder name is incorrect.\nPlease, don't use: \\,/,:,*,?,\",<,>,|,\'");
		}
		
		//Si se ha puesto nombre
		if (!error) {
			//Obtenemos del path
			element = $('path_newfile');
			var file_path = element.options[element.selectedIndex].value;
		
			//Creamos el nombre final del fichero
			var newfile_path = file_path+'/'+file_name;
			
			//Comprobamos que no existe ya un fichero con ese nuevo nombre
			if (filetree_manager.file_exists(newfile_path)) {
				var r = confirm("File exsists. Are you sure to overwrite this file?");
				if (r == true) {
					actions_manager.new_folder(newfile_path);
				}
			}
			else {
				//Llamamos a la accion
				actions_manager.new_folder(newfile_path);
			}
		}
	}
	
	
	
	//Rename folder
	this.show_renamefolder_window = function(path, modal) {
		//Configuramos la ventana
		win = new Window({title: "Rename folder",
						  width:265,
						  height:100,
						  zIndex:3, 
						  minimizable: false,
						  maximizable: false,
						  destroyOnClose: true,
						  recenterAuto:true,
						  resizable:false,
						  showEffect: Element.show,
						  hideEffect: Element.hide});

		//Nos quedamos con el nombre del fichero
		var file_name = path.substring(path.lastIndexOf("/")+1, path.length);
		
		//Creamos las partes del contenido de la ventana
		var window_content = ''+
			'<div id="window_content">'+
				'<div>'+
					'<label for="name_file" style="width:40px">Name: </label>'+
					'<input id="name_file" name="name_file" type="text" style="width:195px" value="'+file_name+'" />'+
				'</div>'+
				'<div style="text-align:center;margin-top:10px">'+
					'<button onclick="windows_manager.submit_rename_folder(\''+path+'\')" style="width:70px;margin:0 5px 0 5px;">OK</button>'+
					'<button onclick="windows_manager.close_current_window()" style="width:70px;margin:0 5px 0 5px;">Cancel</button>'+
				'</div>'+
			'</div>';
			
		//Mostramos la ventana
		win.setHTMLContent(window_content);
		win.showCenter(modal);
	}
	
	
	this.submit_rename_folder = function(path_file) {
		//Obtenemos el nuevo nombre de la carpeta
		var file_name = $('name_file').value;
		
		//Comprobamos el nombre del fichero
		var error = false;
		if (file_name == "") {
			error = true;
		}
		else if (file_name.match(/[\\/:*?\""<>|\']/)) {
			error = true;
			alert("The folder name is incorrect.\nPlease, don't use: \\,/,:,*,?,\",<,>,|,\'");
		}
	
		
		//Si se ha puesto nombre
		if (!error) {
			var path = path_file.substring(0, path_file.lastIndexOf("/")+1);
			var newpath_file = path+file_name;
			//alert(newpath_file);
			
			//Comprobamos que no existe ya un fichero con ese nuevo nombre
			if (filetree_manager.file_exists(newpath_file)) {
				alert("File exists. Imposible to rename this folder");
			}
			else {
				//Cerramos la ventana
				//Windows.getFocusedWindow().close();
				this.close_current_window();				
				//Llamamos a la accion
				actions_manager.rename_folder(path_file, newpath_file);
			}
		}
	}
		


	//Go to line window
	this.show_goto_line_window = function(path) {
		//Configuramos la ventana
		win = new Window({title: "Go to line", 
						  width:200, 
						  height:90, 
						  zIndex:3, 
						  minimizable: false, 
						  maximizable: false, 
						  destroyOnClose: true, 
						  recenterAuto:true, 
						  resizable:false,
						  showEffect: Element.show,
						  hideEffect: Element.hide});

		//Creamos las partes del contenido de la ventana
		var window_content = ''+
			'<div id="window_content">'+
				'<div>'+
					'<label for="name_file">Go to line number: </label>'+
					'<input id="line_number" name="line_number" type="text" style="width:70px;margin-left:10px" />'+
				'</div>'+
				'<div style="text-align:center;margin-top:10px">'+
					'<button onclick="windows_manager.submit_goto_line()" style="width:70px;margin:0 5px 0 5px;">OK</button>'+
					'<button onclick="windows_manager.close_current_window()" style="width:70px;margin:0 5px 0 5px;">Cancel</button>'+
				'</div>'+
			'</div>';
	
		//Mostramos la ventana
		win.setHTMLContent(window_content);
		win.showCenter();
	}

	this.submit_goto_line = function() {
		//Obtenemos la linea
		var line_number = $('line_number').value;
		
		//Comprobamos el nombre del fichero
		var error = false;
		if (line_number == "") {
			error = true;
		}
		
		//Si se ha puesto la linea
		if (!error) {
			editAreaLoader.execCommand('editor_content','go_to_line',line_number);
			//Windows.getFocusedWindow().close();
		}
	}
	
	
	this.show_search_window = function() {
		//Configuramos la ventana
		win = new Window({title: "Search", 
						  width:310, 
						  height:185, 
						  zIndex:3, 
						  minimizable: false, 
						  maximizable: false, 
						  destroyOnClose: true, 
						  recenterAuto:true, 
						  resizable:false,
						  showEffect: Element.show,
						  hideEffect: Element.hide});

		//Creamos las partes del contenido de la ventana
		var window_content = ''+
			'<div id="window_content">'+
				'<div id=area_search_replace">'+
					'<div style="margin-bottom:5px">'+
						'<label for="area_search" style="width:50px;">Search: </label>'+
						'<input id="area_search" name="area_search" type="text" style="width:215px;" />'+
					'</div>'+
					'<div style="margin-bottom:5px">'+
						'<label for="area_replace" style="width:50px;">Replace: </label>'+
						'<input id="area_replace" name="area_replace" type="text" style="width:215px;" />'+
					'</div>'+
					'<div>'+
						 '<input id="area_search_match_case" type="checkbox" /><label for="area_search_match_case" selec="none"> Match case</label>'+
					'</div>'+
					'<div>'+
						 '<input id="area_search_reg_exp" type="checkbox" /><label for="area_search_reg_exp" selec="none"> Regular expressions</label>'+
					'</div>'+
					'<div style="text-align:center;margin:10px 0 10px 0">'+
						'<button onclick="editAreaLoader.execCommand(\'editor_content\', \'area_search()\')" style="width:80px;margin:0 5px 0 5px;font-size:10px;">Find next</button>'+
						'<button onclick="editAreaLoader.execCommand(\'editor_content\', \'area_replace()\')" style="width:80px;margin:0 5px 0 5px;font-size:10px;">Replace</button>'+
						'<button onclick="editAreaLoader.execCommand(\'editor_content\', \'area_replace_all()\')" style="width:80px;margin:0 5px 0 5px;font-size:10px;">Replace all</button>'+
					'</div>'+
					'<div id="area_search_msg" style="height:18px;overflow:hidden;border-top:solid 1px #DEDEDE;padding-top:5px" selec="none"></div>'+
				'</div>'+
			'</div>';
	
		//Mostramos la ventana
		win.setHTMLContent(window_content);
		win.showCenter();
	}
	


	this.is_open_window = function() {
		return Windows.windows.length > 0;
	}
	//FUNCIONES AUXILIARES
	
	
}


var windows_manager = new Windows_Manager();
